#include "QWBFZAlgComponetXmlParamsDialog.h"
#include "ui_QWBFZAlgComponetXmlParamsDialog.h"
#include <QFileDialog>
#include <QMessageBox>
#include "WBFZAlgComponetXmlParaseOperator.h"
#include "FileOperator.h"
QWBFZAlgComponetXmlParamsDialog::QWBFZAlgComponetXmlParamsDialog(QWidget *parent)
	: QDialog(parent),
	ui(new Ui::QWBFZAlgComponetXmlParamsDialogClass)
{
	ui->setupUi(this);

	// ź-
	QObject::connect(ui->buttonBox, SIGNAL(accepted()), this, SLOT(OnacceptButton_Clicked()));
	QObject::connect(ui->buttonBox, SIGNAL(rejected()), this, SLOT(OncancelButton_Clicked()));




}

QWBFZAlgComponetXmlParamsDialog::~QWBFZAlgComponetXmlParamsDialog()
{
	delete ui;
	delete xmlParseOperator;
}

void QWBFZAlgComponetXmlParamsDialog::OnacceptButton_Clicked()
{
	// ȡֵ
	QString workspacePath = workspacePathWidget->getValue();
	qDebug() << "workspacePath:" << workspacePath;
	QMap<QString, QString> parameterMap;
	for (long i = 0; i < parameterWidgetList.size(); i++)
	{
		AbstractComponentWidget* parameterWidget = parameterWidgetList.at(i);
		QString parameterValue = parameterWidget->getValue();
		qDebug() << "parameterValue:" << parameterValue;
		parameterMap.insert(parameterWidget->getParaName(), parameterValue);
	}

	// 1. ȡxmlļģ·
	QString formatxmlpath = this->formatxmlString;
	// 2. ȡxmlļ·
	QString filepath = QFileDialog::getSaveFileName(this, u8"xmlļ", "", u8"xmlļ(*.xml)");
	if (filepath.isEmpty())
	{
		QMessageBox::warning(this, u8"", u8"ѡxmlļ");
		return;
	}
	else {
		qDebug() << "filepath:" << filepath;
	}
	xmlParseOperator = new WBFZAlgComponetXmlParaseOperator(this);
	xmlParseOperator->writeXmlFile(formatxmlString, filepath, workspacePath,parameterMap);
	// 3. رմ
	QMessageBox::information(nullptr, u8"ʾ", u8"д");
}

void QWBFZAlgComponetXmlParamsDialog::OncancelButton_Clicked()
{
	this->close();
}

void QWBFZAlgComponetXmlParamsDialog::loadXmlFile(const QString& fileName)
{
	if (nullptr != xmlParseOperator)
	{
		delete xmlParseOperator;
		xmlParseOperator = nullptr;
	}
	else {}
	this->formatxmlString = fileName;
	// xml
	xmlParseOperator = new WBFZAlgComponetXmlParaseOperator(this);
	xmlParseOperator->loadXmlFile(fileName);

	// ݽui
	// 1. workspace·
	workspacePathWidget = new FileSelectWidget(this);
	workspacePathWidget->setParaName("WorkSpace");
	workspacePathWidget->setParaChsName(u8"ռ·");
	workspacePathWidget->setDescription(u8"ռ·");
	workspacePathWidget->setDatatype(u8"string");
	workspacePathWidget->setComponentType(ComponentType::FolderSelect);
	workspacePathWidget->initUI();

	ui->verticalLayout_param->addWidget(workspacePathWidget);
	// 2. б
	QList < WBFZAlgComponetXmlParamenterItem*> parameterList = xmlParseOperator->getParameterList();
	for (long i = 0; i < parameterList.size(); i++)
	{
		WBFZAlgComponetXmlParamenterItem* item = parameterList.at(i);
		qDebug() << "item->getParaName():" << item->getParaName();
		// 
		AbstractComponentWidget* parameterWidget = createComponentWidgetFactory(
			item->getParaName(),
			item->getParaChsName(),
			item->getDatatype(),
			item->getParaType(),
			item->getDescription(),
			this);
		//parameterWidget->initUI();

		ui->verticalLayout_param->addWidget(parameterWidget);

		this->parameterWidgetList.append(parameterWidget);

	}

}

void WBFZAlgComponetLoadXmlParamsProcess()
{
	QString xmlFileName = QFileDialog::getOpenFileName(nullptr, u8"ѡ㷨xmlļ", "", u8"xmlļ(*.xml)");
	if (xmlFileName.isEmpty())
	{
		QMessageBox::warning(nullptr, u8"", u8"ѡ㷨xmlļ");
		return;
	}
	else {
		// TODO: xmlļز
		qDebug() << "xmlFileName:" << xmlFileName;

		QWBFZAlgComponetXmlParamsDialog* dialog = new QWBFZAlgComponetXmlParamsDialog();
		dialog->setWindowTitle(QString(u8"㷨xmlļ-%1").arg(getFileNameFromPath(xmlFileName)));
		dialog->loadXmlFile(xmlFileName);
		dialog->show();
		return;
	}
	return;
}
